'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


Imports System
Imports System.Data
Imports System.Collections
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IProductsCollection 
		
        Property item(ByVal index As Integer) As Products
        Sub Add(ByRef objValue As Products)
        Sub Remove(ByRef objValue As Products)
        Function Contains(ByRef objValue As Products) As Boolean
        Function IsContain(ByVal value As Products) As Int64

    End Interface
	

	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class ProductsCollection
	    Inherits   Collection
	    Implements IProductsCollection 
        Public Sub New()
            '--
        End Sub

		' <summary>
		' Gets the <c>Products</c> object at the specified index.
		' </summary>
		' <value>The <c>Products</c> object.</value>
        Default Public Shadows Property item(ByVal index As Integer) As Products _
            Implements IProductsCollection.item
            Get
                Return CType(MyBase.Item(index), Products)
            End Get
			Set
				MyBase.Item(index) = value
			End Set
			
        End Property

        Public Overloads Sub Add(ByRef value As Products) _
            Implements IProductsCollection.Add

            MyBase.Add(value)
        End Sub

        Public Overloads Sub Remove(ByRef value As Products) _
            Implements IProductsCollection.Remove

            MyBase.Remove(value)
        End Sub

		' <summary>
		' If value is not of type object, this will return false.
		' </summary>
        Public Overloads Function Contains(ByRef value As Products) As Boolean _
            Implements IProductsCollection.Contains

            Return MyBase.Contains(value)
        End Function

        Public Function IsContain(ByVal value As Products) As Int64 _
            Implements IProductsCollection.IsContain

            Dim _products As Products
            Dim index As Int32 = 0

            For Each _products In List

                If _products.CompareTo(value) Then
                    Return index
                End If

                index = index + 1
            Next
            Return -1
        End Function
    End Class
End Namespace