'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================



Imports System
Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices
Imports System.Globalization
Imports System.Resources
Imports System.Collections
Imports TDevFramework

 Namespace NCacheSample

	Public Interface IEmployees
		
	
		Property EmployeeID() As Int32
		Property LastName() As String
		Property FirstName() As String
		Property Title() As String
		Property TitleOfCourtesy() As String
		Property BirthDate() As DateTime
		Property HireDate() As DateTime
		Property Address() As String
		Property City() As String
		Property Attrib_Region() As String
		Property PostalCode() As String
		Property Country() As String
		Property HomePhone() As String
		Property Extension() As String
		Property Photo() As Byte() 
		Property Notes() As String
		Property ReportsTo() As Int32
	End Interface
	
	< ClassInterface(ClassInterfaceType.AutoDual), Serializable()> _
	Public Class Employees 
		        Inherits PersistentObject
				Implements IEmployees, IComparable 
	
		Private _Photo As Byte () = Nothing
        Public Sub New()
            SetupFields()
        End Sub

		
		' <summary>
		' Gets or sets the <c>EmployeeID</c> attribute value.
		' </summary>
		' <value>The <c>EmployeeID</c> attribute value.</value>
        Public Property EmployeeID() As Int32 _
            Implements IEmployees.EmployeeID
			Get
                If (Not me("EmployeeID").Null) Then
                    Return CType(me("EmployeeID").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("EmployeeID").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>LastName</c> attribute value.
		' </summary>
		' <value>The <c>LastName</c> attribute value.</value>
        Public Property LastName() As String _
            Implements IEmployees.LastName
			Get
                If (Not me("LastName").Null) Then
                    Return CType(me("LastName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("LastName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>FirstName</c> attribute value.
		' </summary>
		' <value>The <c>FirstName</c> attribute value.</value>
        Public Property FirstName() As String _
            Implements IEmployees.FirstName
			Get
                If (Not me("FirstName").Null) Then
                    Return CType(me("FirstName").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("FirstName").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Title</c> attribute value.
		' </summary>
		' <value>The <c>Title</c> attribute value.</value>
        Public Property Title() As String _
            Implements IEmployees.Title
			Get
                If (Not me("Title").Null) Then
                    Return CType(me("Title").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Title").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>TitleOfCourtesy</c> attribute value.
		' </summary>
		' <value>The <c>TitleOfCourtesy</c> attribute value.</value>
        Public Property TitleOfCourtesy() As String _
            Implements IEmployees.TitleOfCourtesy
			Get
                If (Not me("TitleOfCourtesy").Null) Then
                    Return CType(me("TitleOfCourtesy").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("TitleOfCourtesy").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>BirthDate</c> attribute value.
		' </summary>
		' <value>The <c>BirthDate</c> attribute value.</value>
        Public Property BirthDate() As DateTime _
            Implements IEmployees.BirthDate
			Get
                If (Not me("BirthDate").Null) Then
                    Return CType(me("BirthDate").Value, DateTime)
                Else
                    Return New DateTime()
                End If
			End Get
			Set(ByVal Value As DateTime)
				me("BirthDate").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>HireDate</c> attribute value.
		' </summary>
		' <value>The <c>HireDate</c> attribute value.</value>
        Public Property HireDate() As DateTime _
            Implements IEmployees.HireDate
			Get
                If (Not me("HireDate").Null) Then
                    Return CType(me("HireDate").Value, DateTime)
                Else
                    Return New DateTime()
                End If
			End Get
			Set(ByVal Value As DateTime)
				me("HireDate").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Address</c> attribute value.
		' </summary>
		' <value>The <c>Address</c> attribute value.</value>
        Public Property Address() As String _
            Implements IEmployees.Address
			Get
                If (Not me("Address").Null) Then
                    Return CType(me("Address").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Address").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>City</c> attribute value.
		' </summary>
		' <value>The <c>City</c> attribute value.</value>
        Public Property City() As String _
            Implements IEmployees.City
			Get
                If (Not me("City").Null) Then
                    Return CType(me("City").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("City").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Attrib_Region</c> attribute value.
		' </summary>
		' <value>The <c>Attrib_Region</c> attribute value.</value>
        Public Property Attrib_Region() As String _
            Implements IEmployees.Attrib_Region
			Get
                If (Not me("Attrib_Region").Null) Then
                    Return CType(me("Attrib_Region").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Attrib_Region").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>PostalCode</c> attribute value.
		' </summary>
		' <value>The <c>PostalCode</c> attribute value.</value>
        Public Property PostalCode() As String _
            Implements IEmployees.PostalCode
			Get
                If (Not me("PostalCode").Null) Then
                    Return CType(me("PostalCode").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("PostalCode").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Country</c> attribute value.
		' </summary>
		' <value>The <c>Country</c> attribute value.</value>
        Public Property Country() As String _
            Implements IEmployees.Country
			Get
                If (Not me("Country").Null) Then
                    Return CType(me("Country").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Country").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>HomePhone</c> attribute value.
		' </summary>
		' <value>The <c>HomePhone</c> attribute value.</value>
        Public Property HomePhone() As String _
            Implements IEmployees.HomePhone
			Get
                If (Not me("HomePhone").Null) Then
                    Return CType(me("HomePhone").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("HomePhone").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Extension</c> attribute value.
		' </summary>
		' <value>The <c>Extension</c> attribute value.</value>
        Public Property Extension() As String _
            Implements IEmployees.Extension
			Get
                If (Not me("Extension").Null) Then
                    Return CType(me("Extension").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Extension").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Photo</c> attribute value.
		' </summary>
		' <value>The <c>Photo</c> attribute value.</value>
		Public Property Photo() As Byte() _
            Implements IEmployees.Photo
			Get
				Return _Photo
			End Get
            Set(ByVal Value As Byte())
                _Photo = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>Notes</c> attribute value.
		' </summary>
		' <value>The <c>Notes</c> attribute value.</value>
        Public Property Notes() As String _
            Implements IEmployees.Notes
			Get
                If (Not me("Notes").Null) Then
                    Return CType(me("Notes").Value, String)
                Else
                    Return Nothing
                End If
			End Get
			Set(ByVal Value As String)
				me("Notes").Value = Value
			End Set
		End Property
		
		' <summary>
		' Gets or sets the <c>ReportsTo</c> attribute value.
		' </summary>
		' <value>The <c>ReportsTo</c> attribute value.</value>
        Public Property ReportsTo() As Int32 _
            Implements IEmployees.ReportsTo
			Get
                If (Not me("ReportsTo").Null) Then
                    Return CType(me("ReportsTo").Value, Int32)
                Else
                    Return New Int32()
                End If
			End Get
			Set(ByVal Value As Int32)
				me("ReportsTo").Value = Value
			End Set
		End Property
		Public  Function  SetNull(ByVal szFieldName As String ,ByVal bNull As Boolean)
			me(szFieldName).Null = bNull
		End Function

		Public  Function  IsNull(ByVal szFieldName As String) As Boolean
			Return me(szFieldName).Null
		End Function

        Public Overloads Function CompareTo(ByVal obj As Object) As Integer Implements IComparable.CompareTo
            Try
                If TypeOf obj Is Employees Then
                    Dim cmpEmployees As Employees = CType(obj, Employees)
                    If EmployeeID.CompareTo(cmpEmployees.EmployeeID) = 0  Then
                        Return 1
                    Else
                        Return 0
                    End If
                End If
            Catch ex As Exception
                Throw New ArgumentException("object is not an instance of Employees")
            End Try
            
        End Function
        Private Function SetupFields()

            AddField(New PersistentField("EmployeeID", True, True, TDevFramework.EDataType.eInt))
            AddField(New PersistentField("LastName", True, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("FirstName", True, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Title", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("TitleOfCourtesy", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("BirthDate", False, False, TDevFramework.EDataType.eDateTime))
            AddField(New PersistentField("HireDate", False, False, TDevFramework.EDataType.eDateTime))
            AddField(New PersistentField("Address", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("City", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Attrib_Region", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("PostalCode", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Country", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("HomePhone", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Extension", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("Notes", False, False, TDevFramework.EDataType.eVarchar))
            AddField(New PersistentField("ReportsTo", False, False, TDevFramework.EDataType.eInt))
        End Function

        Public Sub Copy(ByVal objInfo As Employees)
            Me.EmployeeID = objInfo.EmployeeID
            Me.LastName = objInfo.LastName
            Me.FirstName = objInfo.FirstName
            Me.Title = objInfo.Title
            Me.TitleOfCourtesy = objInfo.TitleOfCourtesy
            Me.BirthDate = objInfo.BirthDate
            Me.HireDate = objInfo.HireDate
            Me.Address = objInfo.Address
            Me.City = objInfo.City
            Me.Attrib_Region = objInfo.Attrib_Region
            Me.PostalCode = objInfo.PostalCode
            Me.Country = objInfo.Country
            Me.HomePhone = objInfo.HomePhone
            Me.Extension = objInfo.Extension
            Me.Photo = objInfo.Photo
            Me.Notes = objInfo.Notes
            Me.ReportsTo = objInfo.ReportsTo
            'Me.Dirty = objInfo.Dirty
            'Me.IsNew = objInfo.IsNew
        End Sub
    End Class
End Namespace