'===============================================================================
' Copyright 2014 Alachisoft.  All rights reserved.
'===============================================================================


Imports System
Imports System.Xml
Imports NCacheSample

#Region "Class InventoryUpdater"
Public Class InventoryUpdaterForm
    Inherits System.Windows.Forms.Form
#Region "Members"
    'Thread which periodically update inventory '
    Private _inventoryUpdater As InventoryUpdater
    'Flag set when inventory updater thread has started'
    Private _started As Boolean
    'Interval after which inventory is to be updated'
    Private _interval As Integer
    'Id of the cache to be started'
    Private _cacheId As String


#End Region

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call
        _cacheId = "myCache"
    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    Public WithEvents Label1 As System.Windows.Forms.Label
    Public WithEvents Label2 As System.Windows.Forms.Label
    Public WithEvents Label3 As System.Windows.Forms.Label
    Public WithEvents _txtInterval As System.Windows.Forms.TextBox
    Public WithEvents _btnStart As System.Windows.Forms.Button
    Public WithEvents _txtLog As System.Windows.Forms.TextBox
    Public WithEvents _btnDone As System.Windows.Forms.Button
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(InventoryUpdaterForm))
        Me.Label1 = New System.Windows.Forms.Label
        Me.Label2 = New System.Windows.Forms.Label
        Me.Label3 = New System.Windows.Forms.Label
        Me._txtInterval = New System.Windows.Forms.TextBox
        Me._btnStart = New System.Windows.Forms.Button
        Me._txtLog = New System.Windows.Forms.TextBox
        Me._btnDone = New System.Windows.Forms.Button
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Font = New System.Drawing.Font("Microsoft Sans Serif", 9.75!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Label1.Location = New System.Drawing.Point(12, 12)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(268, 20)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "Demonstrating NCache Synchronization"
        '
        'Label2
        '
        Me.Label2.Location = New System.Drawing.Point(12, 36)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(316, 20)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "This simulates increase and decrease in inventory in realtime."
        '
        'Label3
        '
        Me.Label3.Location = New System.Drawing.Point(32, 69)
        Me.Label3.Name = "Label3"
        Me.Label3.Size = New System.Drawing.Size(84, 16)
        Me.Label3.TabIndex = 2
        Me.Label3.Text = "Interval (Sec.) :"
        '
        '_txtInterval
        '
        Me._txtInterval.Location = New System.Drawing.Point(120, 67)
        Me._txtInterval.Name = "_txtInterval"
        Me._txtInterval.Size = New System.Drawing.Size(28, 20)
        Me._txtInterval.TabIndex = 3
        Me._txtInterval.Text = "1"
        '
        '_btnStart
        '
        Me._btnStart.BackColor = System.Drawing.SystemColors.ActiveBorder
        Me._btnStart.Location = New System.Drawing.Point(156, 63)
        Me._btnStart.Name = "_btnStart"
        Me._btnStart.Size = New System.Drawing.Size(68, 24)
        Me._btnStart.TabIndex = 4
        Me._btnStart.Text = "S&tart"
        '
        '_txtLog
        '
        Me._txtLog.Font = New System.Drawing.Font("Courier New", 8.25!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me._txtLog.Location = New System.Drawing.Point(16, 99)
        Me._txtLog.Multiline = True
        Me._txtLog.Name = "_txtLog"
        Me._txtLog.ScrollBars = System.Windows.Forms.ScrollBars.Both
        Me._txtLog.Size = New System.Drawing.Size(404, 172)
        Me._txtLog.TabIndex = 5
        Me._txtLog.Text = ""
        '
        '_btnDone
        '
        Me._btnDone.BackColor = System.Drawing.SystemColors.ActiveBorder
        Me._btnDone.Location = New System.Drawing.Point(236, 63)
        Me._btnDone.Name = "_btnDone"
        Me._btnDone.Size = New System.Drawing.Size(68, 24)
        Me._btnDone.TabIndex = 6
        Me._btnDone.Text = "&Done"
        '
        'InventoryUpdater
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
        Me.BackColor = System.Drawing.Color.WhiteSmoke
        Me.ClientSize = New System.Drawing.Size(442, 291)
        Me.Controls.Add(Me._btnDone)
        Me.Controls.Add(Me._txtLog)
        Me.Controls.Add(Me._txtInterval)
        Me.Controls.Add(Me._btnStart)
        Me.Controls.Add(Me.Label3)
        Me.Controls.Add(Me.Label2)
        Me.Controls.Add(Me.Label1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "InventoryUpdaterForm"
        Me.Text = "Inventory Updater"
        Me.ResumeLayout(False)

    End Sub

#End Region

#Region "Event Handlers"
    'loads the inventory updateer
    Private Sub OnInventoryUpdaterLoad(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        GetCacheID()
    End Sub
    'Starts / Stops the inventory updaer thread'
    Private Sub OnStart(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _btnStart.Click

        Try
            If Not _started Then
                If ValidateIntervals() Then
                    NCacheUtil.InitCache(False, _cacheId)

                    _inventoryUpdater = New InventoryUpdater(Me)
                    _inventoryUpdater.StartUpdate()
                    Me._btnStart.Text = "&Stop"
                    _started = True
                    Me._btnDone.Enabled = False
                Else
                    MessageBox.Show("Invalid Interval", "Inventory Updater", MessageBoxButtons.OK, MessageBoxIcon.Warning)
                End If
            Else
                If Not Me._inventoryUpdater Is Nothing Then
                    Me._inventoryUpdater.StopUpdate()
                End If
                Me._btnStart.Text = "&Start"
                _started = False
                Me._btnDone.Enabled = True
            End If
        Catch ex As Exception
        End Try

    End Sub
    'Close the inventory updation window'
    Private Sub OnDone(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles _btnDone.Click
        NCacheUtil.DisposeCache()
        Me.Close()
    End Sub
    'Safely stops the thread if running'
    Private Sub OnClose(ByVal sender As System.Object, ByVal e As System.ComponentModel.CancelEventArgs) Handles MyBase.Closing

        If Not Me._inventoryUpdater Is Nothing Then
            Me._inventoryUpdater.StopUpdate()
        End If
    End Sub
#End Region

#Region "Utility Methods"
    'Gets the ID of the cache from configuraton file
    Private Sub GetCacheID()
        Try
            _cacheId = System.Configuration.ConfigurationSettings.AppSettings.Get("NCache.CacheId")
        Catch ex As Exception
            _cacheId = "myCache"
        End Try
    End Sub
    'Checks whether interval given by the user is in valid range (1-60)'
    Public Function ValidateIntervals() As Boolean
        Dim validated = False
        Try
            _interval = Convert.ToInt64(Me._txtInterval.Text)
            If _interval < 1 Or _interval > 60 Then
                Throw New Exception("Not valid")
            End If
            validated = True
        Catch ex As Exception
        End Try
        Return validated
    End Function
    'Initializes the log '
    Public Sub InitializeLog()
        Me._txtLog.Text = " Inventory Update Log" + ControlChars.NewLine
        Me._txtLog.AppendText(String.Format("{0,48}", "Quantity") + ControlChars.NewLine)
        Me._txtLog.AppendText(String.Format("{0,48}", "--------") + ControlChars.NewLine)
        Me._txtLog.AppendText(String.Format("{0,-4}{1,-35}{2,-3} {3,-3}{4,-3}", "ID", "Name", "Old", ":", "New") + ControlChars.NewLine)
        Me._txtLog.AppendText(String.Format("{0,-4}{1,-35}{2,-3} {3,-3}{4,-3}", "--", "----", "---", ":", "---"))
    End Sub
    'Write the result of updation in Log'
    Public Sub WriteToLog(ByVal product As Products, ByVal oldQuantity As Integer)
        Dim entry As String

        entry = String.Format("{0,-4}{1,-35}{2,-3} {3,-3}{4,-3}", product.ProductID, product.ProductName, oldQuantity.ToString(), ":", product.UnitsInStock.ToString()) & ControlChars.CrLf
        Me._txtLog.AppendText(entry)
        Me._txtLog.Focus()
        Me._txtLog.ScrollToCaret()
    End Sub
    'Write the result of updation in Log'
    Public Sub WriteToLog(ByVal text As String)
        _txtLog.Text += text
    End Sub
#End Region

#Region "Properties"

    Public Property Interval() As Integer
        Get
            Return _interval
        End Get
        Set(ByVal value As Int32)
            _interval = value
        End Set
    End Property
#End Region
End Class
#End Region

#Region "Class UpdateThread"

Public Class InventoryUpdater

    Public Delegate Sub InitializeLogDelegate()
    Public Delegate Sub SetLogTextDelegate(ByVal text As String)
    Public Delegate Sub WriteToLogDelegate(ByVal product As NCacheSample.Products, ByVal quantity As Integer)
    Private _form As InventoryUpdaterForm
    'List of selected indexes for updation'
    Shared _selectedNumbers As ArrayList
    Private _thread As System.Threading.Thread
    Private _onInitializeLog As InitializeLogDelegate
    Private _onWriteToLog As WriteToLogDelegate
    Private _onSetTextToLog As SetLogTextDelegate
    Private _doWork As Boolean
    Public Sub New(ByVal form As InventoryUpdaterForm)
        _form = form
    End Sub
    Public Sub UpdateInventory()
        Dim products As ProductsCollection
        Dim selProducts As ProductsCollection
        Dim product As Products
        Dim increase As Boolean
        Dim oldQuantity As Integer
        Dim noOfLogEntry As Short = 0

        If _form Is Nothing Then
            Return
        End If
        _onInitializeLog = New InitializeLogDelegate(AddressOf _form.InitializeLog)
        _onWriteToLog = New WriteToLogDelegate(AddressOf _form.WriteToLog)
        _onSetTextToLog = New SetLogTextDelegate(AddressOf _form.WriteToLog)

        _form.Invoke(_onInitializeLog)
        Try
            While True
                products = GetProducts()
                If Not products Is Nothing Then
                    If noOfLogEntry > 60 Then
                        _form.Invoke(_onInitializeLog)
                        noOfLogEntry = 0
                    End If
                    _form.Invoke(_onSetTextToLog, New Object() {ControlChars.NewLine})
                    selProducts = SelectedProducts(GetHowManyProducts, products)
                    For Each product In selProducts.Items
                        oldQuantity = product.UnitsInStock
                        If product.UnitsInStock < 10 Then
                            product.UnitsInStock += 20
                        ElseIf increase Then
                            product.UnitsInStock += 1
                            increase = False
                        Else
                            product.UnitsInStock -= 1
                            increase = True
                        End If
                        _form.Invoke(_onWriteToLog, New Object() {product, oldQuantity})
                        noOfLogEntry += 1
                    Next
                End If
                UpdateProduct(products)
                Threading.Thread.Sleep(_form.Interval * 1000)

            End While
        Catch ex As Threading.ThreadInterruptedException
            Return
        Catch ex2 As Exception
        End Try
    End Sub

#Region "Utitlity Operations"

    Public Sub StartUpdate()
        Try
            If Not _thread Is Nothing Then
                _thread.Interrupt()
            End If

            _thread = New Threading.Thread(AddressOf UpdateInventory)
            _thread.Start()
        Catch ex As Exception

        End Try
    End Sub
    Public Sub StopUpdate()
        Try
            If Not _thread Is Nothing Then
                _thread.Interrupt()
            End If
        Catch ex As Exception
        End Try
    End Sub

   

    'Periodically updates the inventory'

    'Random selects the numbers of products to be updated'
    Public Function GetHowManyProducts() As Integer
        Dim rand As System.Random = New System.Random
        Dim number As Integer
        number = 1
        While number < 2 Or number > 6
            number = rand.NextDouble() * 10.0
        End While
        Return number
    End Function
    'Gets the collection from products to be updated'
    Public Function GetProducts() As ProductsCollection
        Dim productFactory As ProductsFactory
        Dim products As ProductsCollection
        Try
            productFactory = New ProductsFactory
            products = productFactory.getAll(True)
        Catch ex As Exception
        End Try
        GetProducts = products
    End Function
    'Updates the products'
    Public Sub UpdateProduct(ByRef products As ProductsCollection)
        Dim productFactory As ProductsFactory
        Dim product As Products
        Try
            productFactory = New ProductsFactory
            If products.Count > 0 Then
                products = productFactory.Save(products, 0, True)
            End If
        Catch ex As Exception
        End Try
    End Sub
    'Returns randomly selected products for updation'
    Public Function SelectedProducts(ByVal noOfSelectedProducts As Integer, ByRef products As ProductsCollection) As ProductsCollection
        Dim selected As Integer
        Dim selProducts As ProductsCollection = New ProductsCollection
        _selectedNumbers = New ArrayList
        While selected < noOfSelectedProducts
            selProducts.Add(products.item(SelectRandomProductsNumber(products.Count)))
            selected += 1
        End While
        Return selProducts
    End Function
    'Gets the randomly product index in collection for updation'
    Public Function SelectRandomProductsNumber(ByVal totalProducts As Integer) As Integer
        Dim rand As System.Random = New System.Random
        Dim number As Integer
        Dim selected As Boolean
        number = 1
        While Not selected
            number = rand.Next Mod totalProducts
            selected = IsAlreadySelected(number)
            _selectedNumbers.Add(number)
        End While
        Return number
    End Function
    'Chacks whether the the given product is not already selected'
    Public Shared Function IsAlreadySelected(ByVal number As Integer) As Boolean
        Dim selectedNumber As Integer
        For Each selectedNumber In _selectedNumbers
            If number = selectedNumber Then
                Return False
            End If
        Next
        Return True
    End Function
    

#End Region
End Class
#End Region
